<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/25/2009 *
 * ===================                          Last change: 06/20/2010 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : daily_100_bonus.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Check for 100% click rate order                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nach Mailbestaetigungen mit 100% Klickrate s.    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif ((!isHtmlOutputMode()) || (!isResetModeEnabled())) {
	// Do not execute when script is in CSS mode or no daily reset
	return;
} elseif (!isExtensionActive('bonus')) {
	logDebugMessage(__FILE__, __LINE__, 'Not resetting, needed extension disabled.');
	return;
}

// Debug line
//* DEBUG: */ logDebugMessage(__FILE__, __LINE__, 'Daily reset started.');

// Check for 100% klickrate mails
$result_bonus = SQL_QUERY("SELECT
	`id`, `userid`, `subject`, `timestamp_ordered`, `clicks`, `url`
FROM
	`{?_MYSQL_PREFIX?}_user_stats`
WHERE
	`max_rec`=`clicks` AND
	`clicks` > 0 AND
	`bonus_stats_active`='N'
ORDER BY
	`userid` ASC", __FILE__, __LINE__);

if (!SQL_HASZERONUMS($result_bonus)) {
	// We found some mail orders...
	while ($content = SQL_FETCHARRAY($result_bonus)) {
		// Add points
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `bonus_stats`=`bonus_stats`+{?bonus_stats?} WHERE `userid`=%s LIMIT 1",
			array(bigintval($content['userid'])), __FILE__, __LINE__);

		// Translate some data
		$content['timestamp'] = generateDateTime($content['timestamp_ordered'], 2);

		// Load email template and send email
		$message = loadEmailTemplate('member_stats_bonus', $content, bigintval($content['userid']));
		sendEmail($content['userid'], '{--MEMBER_BONUS_STATS_SUBJECT--}', $message);

		// Update database
		$result_update = SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_stats` SET `bonus_stats_active`='Y' WHERE `id`=%s LIMIT 1",
			array(bigintval($content['id'])), __FILE__, __LINE__);
	} // END - while

	// Handle bonus points
	handleBonusPoints(getConfig('bonus_stats'));
} // END - if

// Free memory
SQL_FREERESULT($result_bonus);

// Debug line
//* DEBUG: */ logDebugMessage(__FILE__, __LINE__, 'Daily reset ended.');

// [EOF]
?>
