<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 07/03/2004 *
 * ===================                          Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_rallye_prices.php                    *
 * -------------------------------------------------------------------- *
 * Short description : Setup rallye prices                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Rallye-Preise einrichten                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isGetRequestParameterSet('rallye')) {
	// Price submitted?
	if (isFormSent('add')) {
		if ((isPostRequestParameterSet('level')) && ((isPostRequestParameterSet('points')) || (isPostRequestParameterSet('info')))) {
			// Submitted data is valid, but maybe we already have this price level?
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_rallye_prices` WHERE `rallye_id`=%s AND `price_level`='%s' LIMIT 1",
			array(bigintval(getRequestParameter('rallye')), bigintval(postRequestParameter('level'))), __FILE__, __LINE__);

			if (SQL_HASZERONUMS($result)) {
				// Ok, new price level entered!
				SQL_QUERY_ESC("INSERT INTO
	`{?_MYSQL_PREFIX?}_rallye_prices`
(`rallye_id`, `price_level`, `points`, `info`)
	VALUES
(%s, %s, '%s', '%s')",
				array(
					bigintval(getRequestParameter('rallye')),
					bigintval(postRequestParameter('level')),
					postRequestParameter('points'),
					postRequestParameter('info')
				), __FILE__, __LINE__);
				displayMessage('{--RALLYE_PRICE_LEVEL_SAVED--}');
			} else {
				// Free memory
				SQL_FREERESULT($result);

				// Price level found
				displayMessage('{--RALLYE_PRICE_ALREADY_FOUND--}');
			}
		}
	} elseif (isFormSent('do_delete')) {
		// Check if at last one line is selected
		if (ifPostContainsSelections()) {
			// Delete selected entries
			foreach (postRequestParameter('sel') as $id => $sel) {
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_rallye_prices` WHERE `id`=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
			} // END - foreach

			// Output message
			displayMessage('{--RALLYE_ENTRIES_DELETED--}');
		} else {
			displayMessage('{--RALLYE_ENTRIES_NOT_DELETED--}');
		}
	} elseif (isFormSent('do_edit')) {
		// Change entries
		foreach (postRequestParameter('level') as $id => $level) {
			// Secure id
			$id = bigintval($id);

			// Update entry
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_rallye_prices`
SET
	`rallye_id`=%s,
	`price_level`=%d,
	`points`=%s,
	`info`='%s'
WHERE
	`id`=%s
LIMIT 1",
				array(
					postRequestParameter('rallye_id', $id),
					bigintval($level),
					postRequestParameter('points', $id),
					postRequestParameter('infos', $id),
					$id
				), __FILE__, __LINE__);
		}

		// Output message
		displayMessage('{--RALLYE_ENTRIES_CHANGED--}');
	}

	if (isFormSent('edit')) {
		// Check if at last one line is selected
		if (ifPostContainsSelections()) {
			// Make selected editable
			$OUT = '';
			foreach (postRequestParameter('sel') as $id => $sel) {
				// Load data to selected rallye
				$result = SQL_QUERY_ESC("SELECT `rallye_id`, `price_level`, `points`, `info` FROM `{?_MYSQL_PREFIX?}_rallye_prices` WHERE `id`=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
				$content = SQL_FETCHARRAY($result);
				SQL_FREERESULT($result);

				// Add more content
				$content['rallye_content'] = generateOptionList('rallye_data', 'id', 'title', $content['rallye_id']);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_config_rallye_edit_row', true, $content);
			} // END - foreach

			// Remember row content
			$content['rows'] = $OUT;

			// Prepare data for the main template
			$content['rallye'] = getRequestParameter('rallye');

			// Load main template
			loadTemplate('admin_config_rallye_edit', false, $content);
		} else {
			// Nothing selected
			$content = '{--RALLYE_NO_PRICES_SELECTED_1--}<a href="{%url=modules.php?module=admin&amp;what=config_rallye_prices&amp;rallye=' . getRequestParameter('rallye') . '%}">{--RALLYE_NO_PRICES_SELECTED_2--}</a>{--RALLYE_NO_PRICES_SELECTED_3--}';
			displayMessage($content);
		}
	} elseif (isFormSent('delete')) {
		// Check if at last one line is selected
		if (ifPostContainsSelections()) {
			// List all prices
			$OUT = '';
			foreach (postRequestParameter('sel') as $id => $sel) {
				// Load data to selected rallye
				$result = SQL_QUERY_ESC("SELECT `rallye_id`, `price_level`, `points`, `info` FROM `{?_MYSQL_PREFIX?}_rallye_prices` WHERE `id`=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
				$content = SQL_FETCHARRAY($result);
				SQL_FREERESULT($result);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_config_rallye_del_row', true, $content);
			} // END - foreach
			$content['rows'] = $OUT;

			// Prepare data for the main template
			$content['rallye'] = getRequestParameter('rallye');

			// Load main template
			loadTemplate('admin_config_rallye_del', false, $content);
		} else {
			// Nothing selected
			$content = '{--RALLYE_NO_PRICES_SELECTED_1--}<a href="{%url=modules.php?module=admin&amp;what=config_rallye_prices&amp;rallye=' . getRequestParameter('rallye') . '%}">{--RALLYE_NO_PRICES_SELECTED_2--}</a>{--RALLYE_NO_PRICES_SELECTED_3--}';
			displayMessage($content);
		}
	} else {
		// a rallye was selected, so check if there are already prices assigned...
		$result = SQL_QUERY_ESC("SELECT `id`, `price_level`, `points`, `info` FROM `{?_MYSQL_PREFIX?}_rallye_prices` WHERE `rallye_id`=%s ORDER BY `price_level` ASC",
			array(bigintval(getRequestParameter('rallye'))), __FILE__, __LINE__);

		if (!SQL_HASZERONUMS($result)) {
			// Load all prices for the selected rallye
			$OUT = '';
			while ($content = SQL_FETCHARRAY($result)) {
				// Load row template and switch color
				$OUT .= loadTemplate('admin_config_rallye_prices_row', true, $content);
			} // END - while

			// Free memory
			SQL_FREERESULT($result);

			// @TODO Rewrite these two constants
			$content['rows'] = $OUT;

			// Prepare data for the main template
			$content['rallye'] = getRequestParameter('rallye');

			// Load main template
			loadTemplate('admin_config_rallye_prices', false, $content);
		} // END - if
	}

	// Add form for adding new price level
	if (!isFormSent('edit')) {
		loadTemplate('admin_add_rallye_prices', false, getRequestParameter('rallye'));
	} // END - if
} else {
	// No rallye selected so display all available without prices
	$result = SQL_QUERY("SELECT
	d.id, d.admin_id, d.start_time, d.end_time, d.title, a.login, d.is_active
FROM
	`{?_MYSQL_PREFIX?}_rallye_data` AS d
LEFT JOIN
	`{?_MYSQL_PREFIX?}_admins` AS a
ON
	d.admin_id=a.id
ORDER BY
	d.start_time DESC", __FILE__, __LINE__);
	if (!SQL_HASZERONUMS($result)) {
		// List found rallyes
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			// Prepare data for the row template
			// @TODO rename: start->start_time, end->end_time
			$content['start'] = generateDateTime($content['start_time'], '3');
			$content['end']   = generateDateTime($content['end_time']  , '3');

			// Load row template and switch color
			$OUT .= loadTemplate('admin_list_rallye_prices_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Load main template
		loadTemplate('admin_list_rallye_prices', false, $OUT);
	} else {
		// No rallyes setup so far
		displayMessage('{--RALLYE_NO_RALLYES_SETUP--}');
	}
}

// [EOF]
?>
